import { ComponentOptions } from 'component-register/types/utils';

export type RefComponentProps<P = {}> = P & {
    componentOptions: {
        element: ComponentOptions['element'];
    };
};
export type ComponentRefProps<TComponent extends (...args: any[]) => any> = {
    component: TComponent;
    data?: any;
} & (TComponent extends () => any ? {
    componentProps?: never;
} : {
    componentProps: Parameters<TComponent>[0];
});
export declare function ComponentRef<TComponent extends (...args: any) => any>(props: ComponentRefProps<TComponent>, options: ComponentOptions): import("solid-js").JSX.Element;
export declare const ComponentRefElementName = "solid-ion-component-ref";
